CDRSKIN(1)

NAME
cdrskin - burns preformatted data to CD-R[W], DVD-R[W], DVD+R[W], DVD-RAM via libburn.

SYNOPSIS
cdrskin [options|track_source_addresses]

DESCRIPTION

cdrskin is a program that provides some of cdrecord's options in a compatible way for CD media. With DVD it has its own ways. You do not need to be superuser for its daily usage.

Overview of features:
Blanking of CD-RW and DVD-RW.
Burning of data or audio tracks to CD,
either in versatile Track at Once mode (TAO)
or in Session at Once mode for seamless tracks.
Multi session on CD (follow-up sessions in TAO only)
or on DVD-R[W] (in Incremental mode) or on DVD+R.
Single session on DVD-RW or DVD-R (Disk-at-once)
or on overwriteable DVD+RW, DVD-RW, DVD-RAM.
Bus scan, burnfree, speed options, retrieving media info, padding, fifo.
See section EXAMPLES at the end of this text.

General information paragraphs:
Track recording model
Write mode selection
Recordable CD Media
Sequentially Recordable DVD Media
Overwriteable DVD Media
Drive preparation and addressing

Track recording model:
The input-output entities which get processed are called tracks. A track stores a stream of bytes.
Each track is initiated by one track source address argument, which may either be "-" for standard input or the address of a readable file. If no write mode is given explicitely then one will be chosen which matches the peculiarities of track sources and the state of the output media.

More than one track can be burned by a single run of cdrskin. In the terms of the MMC standard all tracks written by the same run constitute a session.
Some media types can be kept appendable so that further tracks can be written to them in subsequent runs of cdrskin (see option -multi). Info about the addresses of burned tracks is kept in a table of content (TOC) on media and can be retrieved via cdrskin option -toc. These informations are also used by the operating systems' CD-ROM read drivers.

In general there are two types of tracks: data and audio. They differ in sector size, throughput and readability via the systems' CD-ROM drivers resp. by music CD players. With DVD there is only type data.
If not explicitely option -audio is given, then any track is burned as type data, unless the track source is a file with suffix ".wav" or ".au" and has a header part which identifies it as MS-WAVE resp. SUN Audio with suitable parameters. Such files are burned as audio tracks by default.

While audio tracks just contain a given time span of acoustic vibrations, data tracks may have an arbitray meaning. Nevertheless, ISO-9660 filesystems are established as a format which can represent a tree of directories and files on all major operating systems. Such filesystem images can be produced by programs mkisofs or genisoimage. They can also be extended by follow-up tracks if prepared properly. See the man pages of said programs. cdrskin is able to fulfill the needs about their option -C.
Another type of data track content are archive formats which originally have been developed for magnetic tapes. Only formats which mark a detectable end-of-archive in their data are suitable, though. Well tested are the archivers afio and star. Not suitable seems GNU tar.

Write mode selection:
If none of the options -dao, -tao or -sao is given then the program will try to choose a write mode which matches the defined recording job, the capabilities of the drive and the state of the present media.
So the mentioning of write modes in the following paragraphs and in the examples is not so much a demand that the user shall choose one explicitely, but rather an illustration of what to expect with particular media types.

Recordable CD Media:
CD-R can be initially written only once and eventually extended until they get closed (or are spoiled because they are overly full). After that they are read-only. Closing is done automatically unless option -multi is given which keeps the media appendable.
There are two write modes, -tao and -sao .
-tao allows to use track source of unpredictable length (like stdin) and allows to write further sessions to appendable media. -sao produces audio sessions with seamless tracks but needs predicted track sizes and cannot append sessions to media.
CD-RW media can be blanked to make them re-usable for another round of overwriting. Usually blank=fast is the appropriate option. Blanking damages the previous content but does not make it completely unreadable. It is no effective privacy precaution. Multiple cycles of blanking and overwriting with random numbers might be.

Sequentially Recordable DVD Media:
Currently DVD-RW, DVD-R and DVD+R can be used for the Sequential recording model.
DVD-RW must be in state "Sequential Recording". The media must be either blank or appendable. Newly purchased DVD-RW and DVD-R media are in this state. Used DVD-RW get into blank sequential state by option blank=deformat_sequential .
With DVD-R[W] two write modes may be available:
Mode DAO has many restrictions. It does not work with appendable media, allows no -multi and only a single track. The size of the track needs to be known in advance. So either its source has to be a disk file of recognizable size or the size has to be announced explicitely by options tsize= or tao_to_sao_tsize= .
DAO is the only mode for media which do not offer feature 21h Incremental Streaming. DAO may also be selected explicitely by option -sao . Program growisofs uses DAO on sequential DVD-R[W] media for maximum DVD-ROM/-Video compatibility.
The other mode, Incremental Streaming, is the default write mode if it is available and if the restrictions of DAO would prevent the job. Incremental Streaming may be selected explicitely by option -tao as it resembles much CD TAO by allowing track sources of unpredicted length and to keep media appendable by option -multi . The only restriction towards CD-R[W] is the lack of support for -audio tracks. Multiple tracks per session are permissible.
The write modes for DVD+R resemble those with DVD-R except that with DVD+R each track gets wrapped in an own session. There is no -dummy writing with DVD+R.
Quite deliberately write mode -sao insists in the tradition of a predicted track size and blank media, whereas -tao writes the tracks open ended and allows appendable media.

Overwriteable DVD Media:
Currently types DVD+RW, DVD-RW and DVD-RAM can be overwritten via cdrskin.
DVD+RW and DVD-RAM media get treated as blank media regardless wether they hold data or not. They need no special initial formatting. Options -audio and -multi are not allowed. Only one track is allowed. -toc does not return information about the media content. Currently there is no difference between -sao and -tao. If ever, then -tao will be the mode which preserves the current behavior.
DVD-RW are sold in state "Sequential Recording". To become suitable for the Overwriteable DVD recording model they need to get formatted to state "Restricted Overwrite". Then they behave much like DVD+RW. This formatting can be done by option blank=format_overwrite .
Several programs like dvd+rw-format, cdrecord, wodim, or cdrskin can bring a DVD-RW out of overwriteable state so that it has to be formatted again. If in doubt, just give it a try.

Drive preparation and addressing:
The drives, either CD burners or DVD burners, are accessed via addresses which are specific to libburn and the operating system. Those addresses get listed by a run of cdrskin --devices.
On Linux, they are device files which traditionally do not offer w-permissions for normal users. Because libburn needs rw-permission, it might be only the superuser who is able to get this list without further precautions.
It is consensus that chmod a+rw /dev/sr0 or chmod a+rw /dev/hdc is less security sensitive than chmod u+s /usr/bin/cdrskin. The risk for the drive is somewhat higher but the overall system is much less at stake.

If you only got one CD capable drive then you may leave out cdrskin option dev=. Else you should use this option to address the drive you want.
cdrskin option dev= not only accepts the listed addresses but also traditional cdrecord SCSI addresses which on Linux consist of three numbers: Bus,Target,Lun. There is also a related address family "ATA" which accesses IDE drives not under control of Linux SCSI drivers: ATA:Bus,Target,Lun.
See option -scanbus for getting a list of cdrecord style addresses.
Further are accepted on Linux: links to libburn-suitable device files, device files which have the same major and minor device number, and device files which have the same SCSI address parameters (e.g. /dev/sg0).

OPTIONS

--help
    Show non-cdrecord compatible options.

-help
    Show cdrecord compatible options.

-version
    Print cdrskin id line, compatibility lure line, libburn version, cdrskin version, version timestamp, build timestamp (if available), and then exit.

Alphabetical list of options which are intended to be compatible with original cdrecord by Joerg Schilling:

-atip
    Retrieve some info about media state. With CD-RW print "Is erasable". With DVD media print "book type:" and a media type text.

-audio
    Announces that the subsequent tracks are to be burned as audio. The source is supposed to be uncompressed headerless PCM, 44100 Hz, 16 bit, stereo. For little-endian byte order (which is usual on PCs) use option -swab. Unless marked explicitely by option -data, input files with suffix those parameters and eventually raw audio data get extracted and burned as audio track. Same is done for suffix .au and SUN Audio.
    Option -audio may be used only with CD media and not with DVD.

blank=type
    Blank a CD-RW, a DVD-RW, or format a DVD+/-RW. This is combinable with burning in the same run of cdrskin. The type given with blank= selects the particular behavior:

    help
        Print this list of blanking types.

    all Blank an entire CD-RW or an unformatted DVD-RW. (See also --prodvd_cli_compatible)

    fast
        Minimally blank an entire CD-RW or blank an unformatted DVD-RW. (See also --prodvd_cli_compatible)

    format_overwrite
        Format a DVD-RW to "Restricted Overwrite". The user should bring some patience.
        (Note: blank=format_overwrite* are not original cdrecord options.)

    format_overwrite_quickest
        Like format_overwrite without creating a 128 MB trailblazer session. Leads to "intermediate" state which only allows sequential write beginning from address 0. The "intermediate" state ends after the first session of writing data.

    format_overwrite_full
        For DVD-RW this is like format_overwrite but claims full media size rather than just 128 MB. Most traditional formatting is attempted. No data get written. Much patience is required.
        This option treats already formatted media even if not option -force is given.
        For DVD+RW this is the only supported explicit formatting type. It provides complete "de-icing" so no reader slips on unwritten data areas.

    deformat_sequential
        Like blank=all but with the additional ability to blank overwriteable DVD-RW. This will destroy their formatting and make them sequentially recordable. Another peculiarity is the ability to blank media which appear already blank. This is similar to option -force but does not try to blank media other than recognizable CD-RW and DVD-RW.
        (Note: blank=deformat_sequential* are not original cdrecord options.)

    deformat_sequential_quickest
        Like blank=deformat_sequential but blanking DVD-RW only minimally. This is faster than full blanking but may yield media incapable of Incremental Streaming (-tao).

-checkdrive
    Retrieve some info about the addressed drive. Exits with non-zero value if the drive cannot be found and opened.

-dao
    Alias for option -sao. Write CD in Session at Once mode or DVD-R[W] in Disc-at-once mode.

-data
    Subsequent tracks are data tracks. This option is default and only needed to mark the end of the range of an eventual option -audio.

dev=target
    Set the address of the drive to use. Valid are at least the addresses listed with option --devices, X,Y,Z addresses listed with option -scanbus, ATA:X,Y,Z addresses listed with options dev=ATA -scanbus, and volatile libburn drive numbers (numbering starts at "0"). Other device file addresses which lead to the same drive might work too.
    If no dev= is given, volatile address "dev=0" is assumed. That is the first drive found being available. Better avoid this ambiguity on systems with more than one drive.
    The special target "help" lists hints about available addressing formats. Be aware that deprecated option --old_pseudo_scsi_adr may change the meaning of Bus,Target,Lun addresses.

driveropts=opt
    Set "driveropts=noburnfree" to disable the drive's eventual protection mechanism against temporary lack of source data (i.e. buffer underrun). A drive that announces no such capabilities will not get them enabled anyway, even if attempted explicitely via "driveropts=burnfree".

-dummy
    Try to perform the drive operations without actually affecting the inserted media. There is no guarantee that this will work with a particular combination of drive, media, and write mode. Blanking is prevented reliably, though.

-eject
    Eject the disc after work is done.

-force
    Assume that the user knows better in situations when cdrskin or libburn are insecure about drive or media state. This includes the attempt to blank media which are classified as unknown or unsuitable, and the attempt to use write modes which libburn believes they are not supported by the drive.
    Another application is to enforce blanking or re-formatting of media which appear to be in the desired blank or format state already.
    Caution: Use this only when in urgent need.

fs=size
    Set the fifo size to the given value. The value may have appended letters which multiply the preceding number:
    "k" or "K" = 1024 , "m" or "M" = 1024k , "g" or "G" = 1024m , "s" or "S" = 2048
    Set size to 0 in order to disable the fifo (default is "4m").
    The fifo buffers an eventual temporary surplus of track source data in order to provide the drive with a steady stream during times of temporary lack of track source supply. The larger the fifo, the longer periods of poor source supply can be compensated. But a large fifo needs substantial time to fill up if not curbed via option fifo_start_at=size.

gracetime=seconds
    Set the grace time before starting to write. (Default is 0)

-isosize
    The next track following this option will try to obtain its source size from the header information out of the first few blocks of the source data. If these blocks indicate an ISO-9660 filesystem then its declared size will be used under the assumption that it is a single session filesystem.
    If not, then the burn run will be aborted.
    The range of -isosize is exactly one track. Further tracks may be preceeded by further -isosize options, though. At least 15 blocks of padding will be added to each -isosize track. But be advised to rather use padsize=300k.
    This option can be performed on track sources which are regular files or block devices. For the first track of the session it can be performed on any type of source if there is a fifo of at least 64 kB. See option fs= .

msifile=path
    Run option -msinfo and copy the result line into the file given by path. Unlike -msinfo this option does not redirect all normal output away from standard output. But it may be combined with -msinfo to achieve this.
    Note: msifile=path is actually an option of wodim and not of cdrecord.

-msinfo
    Retrieve multi-session info for preparing a follow-up session by option -C of programs mkisofs or genisoimage. Print result to standard output. This option redirects to stderr all message output except the one of option --tell_media_space and its own result string, which consists of two numbers. The result string shall be used as argument of option -C with said programs. It gives the start address of the most recent session and the predicted start address of the next session to be appended. The string is empty if the most recent session was not written with option -multi.

-multi
    This option keeps the CD or unformatted DVD-R[W] appendable after the current session has been written. Without it the disc gets closed and may not be written any more - unless it is a -RW and gets blanked which causes loss of its content.
    The following sessions can only be written in -tao mode. -multi is prohibited with overwriteable DVD media and with DVD-R[W] DAO write mode. Option --prodvd_cli_compatible eventually makes -multi tolerable but cannot make it work.
    In order to have all filesystem content accessible, the eventual ISO-9660 filesystem of a follow-up session needs to be prepared in a special way by the filesystem formatter program. mkisofs and genisoimage expect particular info about the situation which can be retrieved by cdrskin option -msinfo.
    To retrieve an archive file which was written as follow-up session, you may use option -toc to learn about the "lba" of the desired track number.

-nopad
    Do not add trailing zeros to the data stream. Nevertheless, since there seems to be no use for audio tracks with incomplete last sector, this option applies only to data tracks. There it is default.

-pad
    Add 30 kB of trailing zeros to each data track. (This is not sufficient to avoid problems with various CD-ROM read drivers.)

padsize=size
    Add the given amount of trailing zeros to the next data track. This option gets reset to padsize=0 after that next track is written. It may be set again before the next track argument. About size specifiers, see option fs=.

-raw96r
    Write CD in RAW/RAW96R mode. This mode allows to put more payload bytes into a CD sector but obviously at the cost of error correction. It can only be used for tracks of fixely predicted size. Some drives allow this mode but then behave strange or even go bad for the next few attempts to burn a CD. One should use it only if inavoidable.

-sao
    Write CD in Session At Once mode, a sequential DVD-R[W] in Disc-at-once (DAO) mode, or a DVD+R.
    With CD this mode is able to put several audio tracks on media without producing audible gaps between them.
    With DVD-R[W] this mode can only write a single track. No -multi is allowed with DVD-R[W] -sao.
    -sao is permissible with overwriteable DVD and with DVD+R but actually only imposes restrictions without providing known advantages.
    -sao can only be used for tracks of fixely predicted size. This implies that track arguments which depict stdin or named pipes need to be preceeded by option tsize= or by option tao_to_sao_tsize=.
    -sao cannot be used on appendable media.

-scanbus
    Scan the system for drives. On Linux the drives at /dev/s* and at /dev/hd* are to be scanned by two separate runs. One without dev= for /dev/s* and one with dev=ATA for /dev/hd* devices. (Option --drives lists all available drives in a single run.)
    Drives which are busy or which offer no rw-permission to the user of cdrskin are not listed. Busy drives get reported in form of warning messages.
    The useful fields in a result line are:
    Bus,Target,Lun Number) 'Vendor' 'Mode' 'Revision'

speed=number
    Set speed of drive. With data CD, 1x speed corresponds to a throughput of 150,000 bytes/second. With DVD, 1x = 1,385,000 bytes/second. It is not an error to set a speed higher than is suitable for drive and media. One should stay within a realistic speed range, though.

-swab
    Announce that the raw audio data source of subsequent tracks is byte swapped versus the expectations of cdrecord. This option is suitable for audio where the least significant byte of a 16 bit word is first (little-endian, Intel). Most raw audio data on PC systems are available in this byte order. Less guesswork is needed if track sources are in format MS-WAVE in a file with suffix ".wav".

-tao
    Write CD in Track At Once (TAO) mode, sequential DVD-R[W] in Incremental Streaming mode, or DVD+R without traditional -sao restrictions. This mode also applies pro-forma to overwriteable DVD media.
    Mode -tao can be used with track sources of unpredictable size, like standard input or named pipes. It is also the only mode that can be used for writing to appendable media which already hold data. With unformatted DVD-R[W] it is the only mode which allows -multi.

-toc
    Print the table of content (TOC) which describes the tracks recorded on disc. The output contains all info from option -atip plus lines which begin with "track:", the track number, the word "lba:" and a number which gives the start address of the track. Addresses are counted in CD sectors which with SAO or TAO data tracks hold 2048 bytes each.

    Example. Retrieve an afio archive from track number 2:
        tracknumber=2
        lba=$(cdrskin dev=/dev/cdrom -toc 2>&1 | \
        grep '^track:[ ]*[ 0-9][0-9]' | \
        tail +"$tracknumber" | head -1 | \
        awk '{ print $4}' )
        dd if=/dev/cdrom bs=2048 skip="$lba" | \
        afio -t - | less

tsize=size
    Announces the exact size of the next track source. This is necessary with any write mode other than -tao if the track source is not a regular disk file, but e.g. "-" (standard input) or a named pipe. About size specifiers, see option fs=.
    If the track source does not deliver the predicted amount of bytes, the remainder of the track is padded with zeros. This is not considered an error. If on the other hand the track source delivers more than the announced bytes then the track on media gets truncated to the predicted size and cdrskin exits with non-zero value.

-v  Increment verbose level by one. Startlevel is 0 with only few messages. Level 1 prints progress report with long running operations and also causes some extra lines to be put out with info retrieval options. Level 2 additionally reports about option settings derived from arguments or startup files. Level 3 is for debugging and useful mainly in conjunction with somebody who had a look into the program sourcecode.

Alphabetical list of options which are genuine to cdrskin and intended for normal use:

--allow_setuid
    Disable the loud warning about insecure discrepance between login user and effective user which indicates application of chmod u+s to the program binary. One should not do this chmod u+s , but it is an old cdrecord tradition.

--any_track
    Allow source_addresses to begin with "-" (plus further characters) or to contain a "=" character. By default such arguments are seen as misspelled options. It is nevertheless not possible to use one of the options listed with --list_ignored_options.

assert_write_lba=block_number|byte_address
    Abort if the write address given with this option is not the same as predicted immediately before the write session starts. This option can ensure that a start address which was presumed by a formatter like mkisofs -C is really used by the drive for writing. assert_write_lba=0 effectively demands blank media and excludes appendables.
    Block numbering is peculiar: If the last character of the option string is a letter [a-zA-Z] then the usual unit scaling by "s", "k", "m", etc. applies and the result is divided by 2048. Else the number value of the string is taken as plain block number with block size 2048 byte. (E.g ...=1000 or ...=1000s means block 1000, ...=1m means block 512, ...=4096b means block number 2)

--demand_a_drive
    Exit with a nonzero value if no drive can be found during a bus scan.

--devices
    List the device file addresses of all accessible CD drives. In order to get listed, a drive has to offer rw-permission for the cdrskin user and it may not be busy. The superuser should be able to see all idle drives listed and busy drives reported as "SORRY" messages.
    Each available drive gets listed by a line containing the following fields:
    Number dev='Devicefile' rw-Permissions : 'Vendor' 'Model'
    Number and Devicefile can both be used with option dev=, but number is volatile (numbering changes if drives become busy).

fifo_start_at=size
    Do not wait for full fifo but start burning as soon as the given number of bytes is read. This option may be helpful to bring the average throughput near to the maximum throughput of a drive. A large fs= and a small fifo_start_at= combine a quick burn start and a large savings buffer to compensate for temporary lack of source data. At the beginning of burning, the software protection against buffer underun is as weak as the size of fifo_start_at= . So it is best if the drive offers hardware protection which is enabled automatically if not driveropts=noburnfree is given.

--list_ignored_options
    List all ignored cdrecord options. The "-" options cannot be used as addresses of track sources. No track source address may begin with a text equal to an option which ends by "=". The list is ended by an empty line.

--no_rc
    Only if used as first command line argument this option prevents reading and interpretation of eventual startup files. See section FILES below.

--prodvd_cli_compatible
    Activates behavior modifications with some DVD situations which bring cdrskin nearer to the behavior of cdrecord-ProDVD:
    Option -multi with unsuitable media is not an error but simply has no effect.
    Options blank=fast and blank=all deformat overwriteable DVD-RW media.
    Option blank=fast does indeed minmal blanking with DVD-RW. This may yield media which can only do DAO but not Incremental Streaming.

--single_track
    Accept only the last argument of the command line as track source address.

tao_to_sao_tsize=size
    Set an exact fixed size for the next track to be in effect only if the track source cannot deliver a size prediction and no tsize= was specified and an exact track size prediction is demanded by the write mode.
    This was the fallback from bad old times when cdrskin was unable to burn in mode -tao . It came back with minimally blanked DVD-RW which allow no Incremental Streaming (-tao) resp. with explicitly selected write mode -sao for best DVD-ROM compatibility.
    If the track source delivers less bytes than announced then the missing ones will be filled with zeros.

--tell_media_space
    Prepare a recording session, do not perform it but rather inquire the maximum number of 2048 byte data blocks which may be written in the current state of media with the prepared setup. So this option disables recording of data. It does allow blanking, though, and will measure space afterwards.
    It is not mandatory to give track sources but their nature may influence the available capacity. So for most realistic results one may set up the full burn session and add --tell_media_space. But if one has to expect a cdrskin version prior to 0.3.3 no track source should be given in order not to start an involuntary burn session. In this case set at least -sao or -tao explicitely.
    The result gets printed to standard output. It is 0 or empty if no writing is possible with the given options. This option redirects to stderr all message output except its own result string and eventual output of -msinfo.

write_start_address=byte_offset
    Set the address on media where to start writing the track. With DVD+RW or DVD-RAM byte_offset must be aligned to 2 KB blocks, but better is 32 kB. With DVD-RW 32 kB alignment is mandatory.
    Other media are not suitable for this option yet.

Alphabetical list of options which are only intended for very special situations and not for normal use:

--abort_handler
    Establish default signal handling not to leave a drive in busy state but rather to shut it down and to wait until it has ended the final operations. This option is only needed for revoking eventual --ignore_signals or --no_abort_handler.

--allow_untested_media
    Enable the use of media profiles which have been implemented but not yet tested. Currently this applies to :
    Profile 0015h , DVD-R/DL Sequential (will not allow -multi).
    Profile 002Bh , DVD+R/DL.
    If you really test such media, then please report the outcome on libburn-hackers@pykix.org

dev_translation=<sep><from><sep><to>
    Set drive address alias. This was necessary before cdrskin-0.2.4 to manually translate cdrecord addresses into cdrskin addresses.
    <sep> is a single character which may not occur in the address string <from>. <from> is an address as expected to be given by the user via option dev=. <to> is the address to be used instead whenever <from> is given. More than one translation instruction can be given in one cdrskin run.
    E.g.: dev_translation=+ATA:1,0,0+/dev/sr1 dev_translation=+ATA:1,1,0+/dev/sr2

--drive_abort_on_busy
    Linux specific: Abort process if a busy drive is encountered.

--drive_blocking
    Linux specific: Try to wait for a busy drive to become free. This is not guaranteed to work with all drivers. Some need nonblocking i/o.

--drive_f_setlk
    Linux specific: Try to get exclusive lock on drive device file via fcntl(2).

--drive_not_exclusive
    Linux specific: Combine --drive_not_f_setlk and --drive_not_o_excl.

--drive_not_f_setlk
    Linux specific: Do not try to get exclusive lock on drive device file via fcntl(2).

--drive_not_o_excl
    Linux specific: Do not ask the operating system to prevent opening busy drives. Wether this leads to senseful behavior depends on operating system and kernel.

drive_scsi_dev_family=sr|scd|sg
    Linux specific: Select a SCSI device file family to be used for drive command transactions. Normally this is /dev/sgN on kernel versions < 2.6 and /dev/srN on kernels >= 2.6 . This option allows to explicitely override that default in order to meet other programs at a common device file for each drive. On kernel 2.4 families sr and scd will find no drives.
    Device file family /dev/hdX on kernel >= 2.6 is not affected by this setting.

--drive_scsi_exclusive
    Linux specific: Try to exclusively reserve device files /dev/srN, /dev/scdM, /dev/sgK of drives. This would be helpful to protect against collisions with program growisofs. Regrettably on Linux kernel 2.4 with ide-scsi emulation this seems not to work. Wether it becomes helpful with new Linux systems has to be evaluated.

--fifo_disable
    Disable fifo despite any fs=.

--fifo_per_track
    Use a separate fifo for each track.

--fill_up_media
    Expand the last track of the session to occupy all remaining free space on the media.
    This option overrides option -multi. It will not fill up media if option -sao is given with CD media.
    Caution: This option might increase read compatibility with DVD-ROM drives but with some DVD recorders and media types it might also fail to produce readable media at all. "Your mileage may vary".

grab_drive_and_wait=seconds
    Open the addressed drive, wait the given number of seconds, release the drive, and do normal work as indicated by the other options used. This option helps to explore the program behavior when faced with busy drives. Just start a second cdrskin with option --devices while grab_drive_and_wait= is still active.

--ignore_signals
    Try to ignore any signals rather than to abort the program. This is not a very good idea. You might end up waiting a very long time for cdrskin to finish.

--no_abort_handler
    On signals exit even if the drive is in busy state. This is not a very good idea. You might end up with a stuck drive that refuses to hand out the media.

--no_blank_appendable
    Refuse to blank appendable CD-RW or DVD-RW. This is a feature that was once builtin with libburn. No information available for what use case it was needed.

--no_convert_fs_adr
    Do only literal translations of dev=. This prevents cdrskin from test-opening device files in order to find one that matches the given dev= specifier.
    Partly Linux specific: Such opening is needed for Bus,Target,Lun addresses unless option --old_pseudo_scsi_adr is given. It is also needed to resolve device file addresses which are not listed with cdrskin --devices but nevertheless point to a usable drive. (Like /dev/sg0 using the same SCSI address as /dev/sr0.)

--old_pseudo_scsi_adr
    Linux specific: Use and report literal Bus,Target,Lun addresses rather than real SCSI and pseudo ATA addresses. This method is outdated and was never compatible with original cdrecord.

EXAMPLES

  Get an overview of drives and their addresses:
cdrskin -scanbus
cdrskin dev=ATA -scanbus
cdrskin --devices

  Get info about a particular drive or loaded media:
cdrskin dev=0,1,0 -checkdrive
cdrskin dev=ATA:1,0,0 -v -atip
cdrskin dev=/dev/hdc -toc

  Make used CD-RW or used unformatted DVD-RW writable again:
cdrskin -v dev=/dev/sg1 blank=fast -eject
cdrskin -v dev=/dev/dvd blank=all -eject

  Format DVD-RW to avoid need for blanking before re-use:
cdrskin -v dev=/dev/sr0 blank=format_overwrite

  De-format DVD-RW to make it capable of multi-session again:
cdrskin -v dev=/dev/sr0 blank=deformat_sequential

  Write ISO-9660 filesystem image as only one to blank or formatted media:
cdrskin -v dev=/dev/hdc speed=12 fs=8m \
-sao -eject padsize=300k my_image.iso

  Write compressed afio archive on-the-fly (not possible with minimally blanked DVD-RW):
find . | afio -oZ - | \
cdrskin -v dev=0,1,0 fs=32m speed=8 \
-tao padsize=300k -

  Write multi-session to the same CD, DVD-R[W] or DVD+R:
cdrskin dev=/dev/hdc -v padsize=300k -multi -tao 1.iso
cdrskin dev=/dev/hdc -v padsize=300k -multi -tao 2.iso
cdrskin dev=/dev/hdc -v padsize=300k -multi -tao 3.iso
cdrskin dev=/dev/hdc -v padsize=300k -tao 4.iso

  Get multi-session info for option -C of program mkisofs:
c_values=$(cdrskin dev=/dev/hdc -msinfo 2>/dev/null)
mkisofs ... -C "$c_values" ...

  Inquire free space on media for a -tao -multi run:
x=$(cdrskin dev=/dev/sr0 -tao -multi \
--tell_media_space 2>/dev/null)
echo "Available: $x blocks of 2048 data bytes"

  Write audio tracks to CD:
cdrskin -v dev=ATA:1,0,0 speed=48 -sao \
track1.wav track2.au -audio -swab track3.raw

FILES
If not --no_rc is given as the first argument then cdrskin attempts on startup to read the arguments from the following files:

/etc/default/cdrskin
/etc/opt/cdrskin/rc
/etc/cdrskin/cdrskin.conf
$HOME/.cdrskinrc

The files are read in the sequence given above, but none of them is required for cdrskin to function properly. Each readable line is treated as one single argument. No extra blanks. A first character '#' marks a comment, empty lines are ignored.

  Example content of a startup file:
# This is the default device
dev=0,1,0
# To accomodate to remnant cdrskin-0.2.2 addresses
dev_translation=+1,0,0+0,1,0
# Some more options
fifo_start_at=0
fs=16m

SEE ALSO

Formatting data track sources for cdrskin:
    mkisofs(8), genisoimage(8), afio(1), star(1)

Other CD/DVD burn programs:
    cdrecord(1), wodim(1)

For DVD burning (also tutor of libburn's DVD capabilities):
    growisofs(1)

AUTHOR
cdrskin was written by Thomas Schmitt <scdbackup@gmx.net>.

This manual page was written by George Danchev <danchev@spnet.net> and Thomas Schmitt, for the Debian project and for all others.